import microbit as mbit
import neopixel as neop


def show_6_static_colors():
    leds.clear()
    # MicroPython does not support slicing (e.g., leds[0:10]), so loops are necessary.
    for i in range(0, 10):
        leds[i] = (255, 0, 0)
    for i in range(10, 20):
        leds[i] = (255, 255, 0)
    for i in range(20, 30):
        leds[i] = (0, 255, 0)
    for i in range(30, 40):
        leds[i] = (0, 255, 255)
    for i in range(40, 50):
        leds[i] = (0, 0, 255)
    for i in range(50, 60):
        leds[i] = (255, 0, 255)
    leds.show()


def show_6_rotating_colors():
    offset = 0
    while True:
        for i in range(0 + offset, 10 + offset):
            leds[i % LED_COUNT] = (255, 0, 0)
        for i in range(10 + offset, 20 + offset):
            leds[i % LED_COUNT] = (255, 255, 0)
        for i in range(20 + offset, 30 + offset):
            leds[i % LED_COUNT] = (0, 255, 0)
        for i in range(30 + offset, 40 + offset):
            leds[i % LED_COUNT] = (0, 255, 255)
        for i in range(40 + offset, 50 + offset):
            leds[i % LED_COUNT] = (0, 0, 255)
        for i in range(50 + offset, 60 + offset):
            leds[i % LED_COUNT] = (255, 0, 255)
        leds.show()
        offset = (offset + 1) % LED_COUNT


def rotate_fading_leds():
    leds.clear()
    for fade_val in range(LED_COUNT):
        leds[fade_val % LED_COUNT] = (int(31 / (LED_COUNT - 1) * fade_val),
                                      int(63 / (LED_COUNT - 1) * fade_val),
                                      int(127 / (LED_COUNT - 1) * fade_val))
    leds.show()

    while True:
        for pos in range(LED_COUNT - 1, -1, -1):
            leds[pos] = leds[pos - 1]
        leds.show()


# Pin 8 and 60 LEDs are fix for this hardware setup.
LED_COUNT = 60
leds = neop.NeoPixel(mbit.pin8, LED_COUNT)

show_6_static_colors()
# show_6_rotating_colors()
# rotate_fading_leds()
